image: docker:latest
services:
- docker:dind

stages:
- test
- build
- release

variables:
  DOCKER_REGISTRY:      'index.docker.io'
  CONTAINER_IMAGE:      "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME"
  TEST_IMAGE:           "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA"
  HEAD_IMAGE:           "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:head"
  RELEASE_IMAGE:        "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:latest"
  GITTAG_IMAGE:         "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:$CI_COMMIT_REF_NAME"

Dockerfile:
  stage: test
  image: hadolint/hadolint:latest-debian
  script:
    - hadolint Dockerfile
  rules:
    - changes:
      - "Dockerfile"

Markdown:
  stage: test
  image: pipelinecomponents/markdownlint:latest
  script:
    - mdl --style all --warnings .
  rules:
    - changes:
      - "*.md"

build:
  stage: build
  before_script:
    - docker login --username "$DOCKER_HUB_LOGIN" --password "$DOCKER_HUB_PASSWORD"
  script:
    - docker pull $HEAD_IMAGE || true
    - docker build --cache-from $HEAD_IMAGE --tag $TEST_IMAGE .
    - docker tag $TEST_IMAGE $HEAD_IMAGE
    - docker push $HEAD_IMAGE
    - docker push $TEST_IMAGE
  rules:
    - changes:
        - "Dockerfile"
        - "entrypoint.sh"

release:
  stage: release
  variables:
    GIT_STRATEGY: none
  before_script:
    - docker login --username "$DOCKER_HUB_LOGIN" --password "$DOCKER_HUB_PASSWORD"
  script:
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
  rules:
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
      when: never
    - changes:
        - "Dockerfile"
        - "entrypoint.sh"

pushrm:
  stage: release
  image: letompouce/docker-pushrm
  variables:
    DOCKER_USER: $DOCKER_HUB_LOGIN
    DOCKER_PASS: $DOCKER_HUB_PASSWORD
    PUSHRM_TARGET: "docker.io/letompouce/$CI_PROJECT_NAME"
    # Warning: this must be 100 characters max
    PUSHRM_SHORT: $CI_PROJECT_DESCRIPTION
    PUSHRM_FILE: $CI_PROJECT_DIR/README.md
    PUSHRM_DEBUG: 1
  script:
    - this is ignored by the image entrypoint.
  rules:
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
      when: never
    - changes:
        - "README.md"
